;----------------------------------------------------------------------------
;[ DIV_HL_DE_S ] by Hideaki Omuro
; optimized for size
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
;system:
; standard z80
;version:
; 2000.Jan.22.t
;size:
; 44 bytes
;time:
; 968-1128 clocks
;comments:
; This routine is actually pretty big, but it'll be bigger if i unroll it :P
; If I come up with a better design, then i'll redo this one too...
;
; Divides Int/Int -> Int, Fix/Fix -> Int, or Fix/Int -> Fix
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
;parameters:
; HL = 16-bit dividend, DE = 16-bit divisor
;returns:
; HL = 16-bit quotient, DE = 16-bit remainder
;modifies:
; ABCDEFHL
;----------------------------------------------------------------------------
DIV_HL_DE_S:
   XOR   A                             ; negate divisor
   SUB   E
   LD    E, A
   SBC   A, A
   SUB   D
   LD    D, A

   LD    A, H                          ; A = top 8-bits of dividend
   LD    C, L                          ; C = low 8-bits of dividend
   LD    HL, 0                         ; DE = divisor, quotient = 0

   LD    B, 8                          ; 8 loops (half of 16 bits)
   RLA                                 ; 24-bit shift
_CDHLDE_divloop1:
   ADC   HL, HL
   ADD   HL, DE                        ; compare with divisor
   JR    C, _CDHLDE_noadd1             ; if divisor is smaller
   SBC   HL, DE                        ; restore result
_CDHLDE_noadd1:
   RLA                                 ; 24-bit shift
   DJNZ  _CDHLDE_divloop1

   LD    B, A                          ; C = top 8-bits of current result
   LD    A, C                          ; A = low 8-bits of dividend
   LD    C, B

   LD    B, 8                          ; 8 loops (half of 16 bits)
   RLA                                 ; 24-bit shift
_CDHLDE_divloop2:
   ADC   HL, HL
   ADD   HL, DE                        ; compare with divisor
   JR    C, _CDHLDE_noadd2             ; if divisor is smaller
   SBC   HL, DE                        ; restore result
_CDHLDE_noadd2:
   RLA                                 ; 24-bit shift
   DJNZ  _CDHLDE_divloop2

   EX    DE, HL                        ; DE = remainder
   LD    H, C                          ; HL = quotient
   LD    L, A

   RET
